<template>
	<div id="nodes">
		<div class="nodes-panel">
			<div class="main-column">
				<div class="nodes-grid lightestpink-color " :style="{backgroundImage : 'url('+getImage('network_bkg.svg')+')'}">
					
					<div class="title hustle medium">Network</div>
					
					<div class="graph">
						<div class="paths" v-for="node in grid_nodes" :class="{active : node.available}" >
							<div 
								v-for="path in node.paths"
								class="path" 
								:style="{
									left : (path.start.x * (100/14))+'%',
									top : (path.start.y * (100/7))+'%',
									height : ( (path.type == 'straight' ? 1 : 1.4142) * (path.length * (100/7))) + '%',
									transform : 'rotate('+path.rotation+'deg)'
								}"
							></div>
						</div>
					
						<grid-node 
							v-for="node in grid_nodes" 
							:node="node" 
							:data="node.data"
							:class="{'pink-border' : node.available}"
							@clicked="selectNode(node.id)"
						/>
					</div>
					
					
					<div class="network-score columns-4" v-tooltip="'network_score_tooltip'">
						<div class="flex space text">
							<div class="bold uppercase">{{ getLocale('network_score') }}</div>
							<div class="bold uppercase">{{ network_score }}</div>
						</div>
						
						<div class="score-bar">
							<div class="bar">
								<div class="dot lightestpink-border lightestpink-bkg" :style="{left : (network_score/2)+'%'}"></div>
								<div class="base lightestpink-bkg" :style="{width : (network_score/2)+'%'}"></div>
							</div>
						</div>
					</div>
				</div>
			</div>
		</div>
		
		<div class="structure-panel" :class="{active : selected_node}" >
			<div class="backdrop" v-on:click.self="closeDetail"></div>
				
			<div class="wrapper" v-on:click.self="closeDetail">
				<div v-if="selected_node" v-on:click.self="closeDetail">
					<div class="panel columns-8 center pink-gradient" :data-type="selectedNode.type">
						<close-icon class="close-button" color="#feb3ff"  @clicked="closeDetail"/>
						
						<div class="unlock-node lightestpink-color row-padding col-padding" v-if="selectedNode.data == null">
							<div class="label hustle  lightpink-color">
								<span v-if="selectedNode.available">{{getLocale('unlock_node')}}</span>
								<span v-else>{{getLocale('unavailable_node')}}</span>
							</div>
										
							<div class="header flex space">
								<div class="hustle medium">{{getLocale('structure_main_'+selectedNode.type)}}</div>
								
								<div class="description columns-12">{{getLocale('structure_main_'+selectedNode.type+'_effect')}}</div>
							</div>
							
							<div class="info">
								<div class="flex" v-if="selectedNode.available">
									<div class="logo":style="{backgroundImage : nodeFavicon(new_node_site)}"></div>
									
									<div class="columns-10">
										<div class="last-site-selector" v-if="selectedNode.type == 'builder'">
											<div class="medium-font columns-6 lightpink-color">{{getLocale('select_site_from_list')}}</div>
									
											<div class="row-padding">
												<div class="avaiable-sites" v-if="validSites.length > 0">
													<div 
														class="website flex"
														v-for="site in validSites" 
														:class="{selected : new_node_site == site.url}" 
														v-on:click="new_node_site = site.url"
													>
														<div class="host columns-12 flex space">
															<div>{{site.url}}</div>
															<div>{{getLocale(getBiome(site.url))}}</div>
														</div>
														<div class="choose uppercase"><span>{{getLocale('choose')}}</span></div>
													</div>
												</div>
												
												<div v-else>{{getLocale('empty_last_sites')}}</div>
											</div>
										</div>
										
										<div class="flex">
											<v-button 
												:text="getLocale('unlock')"
												:secondary_text="getNodeCost.toString()"
												:icons="[ 'bytes_black.svg' ]"
												:disabled="checkUnlockRequirement || unlock_node_lock"
												color="green"
												@clicked="unlockNode"
											/>
										</div>
									</div>
								</div>
							</div>
						</div>
						
						<div class="node" v-else>
							<component 
								:is="selectedNode.type"
								:node="selectedNode"
								:last_sites="last_sites"
								@requestlist="requestList"
							></component>
						</div>
					</div>
				</div>
			</div>
		</div>
				
	
		<transition name="fade">
			<div class="vairus-list-container" v-if="structure_vairus_list.active" v-on:click.self="closeList">
				<div class="main-column" v-on:click.self="closeList">
					<div class="inner azure-gradient">
						<div class="wrapper">
							<keep-alive>
								<vairus-list 
									:list="structure_vairus_list.list" 
									:boxes="boxes" 
									:main="false" 
									:stats="true" 
									show_footer="false" 
									@clicked="assignVairus"
								/>
							</keep-alive>
						</div>
						
						<transition name="fade">	
							<div class="loader" v-if="structure_vairus_list.loading">
								<div class="loading">
									<div class="dot"></div>
									<div class="dot"></div>
									<div class="dot"></div>
								</div>
							</div>
						</transition>
					</div>
				</div>
			</div>
		</transition>
	</div>
</template>


<script>
	var browser = browser || chrome;

	import { commonMixin } from '../mixins/common.js';
	import { structuresMixin } from '../mixins/structures.js';
	import { storeGettersMixin } from '../mixins/store_getters.js';
	import VairusList from '../components/VairusList.vue';
	import GridNode from '../components/GridNode.vue';
	import VButton from '../components/VButton.vue';
	import CloseIcon from '../components/CloseIcon.vue';
	import EmptyCard from '../components/EmptyCard.vue';
	import structuresManager from '../classes/structuresManagerClass.js';
	
	import Builder from '../components/main/Builder.vue';
	import Incubator from '../components/main/Incubator.vue';
	import Keygen from '../components/main/Keygen.vue';
	import Decrypter from '../components/main/Decrypter.vue';
	import Compiler from '../components/main/Compiler.vue';
	
	import nodes_data from '../data/nodes.json';
	
	export default {
		props: ['list'],
		data: function () {
			return{
				nodes_data : nodes_data,
				last_sites : [],
				selected_node : null,
				new_node_site : '',
				structure_vairus_list : {
					active : false,
					loading : false,
					list : [],
					boxes : []
				},
				update_time_interval : null,
				gather_disabled : false,
				back_to_dashboard : false
			}
		},
		mounted() {
			//Keybindings
			document.addEventListener('keydown',function(e) {
				if(this.selected_node != null){
					switch(e.which) {
						case 37: // left
							this.nextNode('prev');
							e.preventDefault();
						break;
						case 39: // right
							this.nextNode('next');
							e.preventDefault();
						break;
						case 27: // esc
							this.closeDetail();
							e.preventDefault();
						break;
					}
				}
			}.bind(this));
			
			//Request network data
			browser.runtime.sendMessage({ type : 'request_structures' });
			
			//Background message handler
			browser.runtime.onMessage.addListener( function(request) {
				switch(request.type){
					case 'sync_nodes':
						let message = request.data;
						
						switch(message.type){
							case 'all_data':
								this.$store.commit('setNodes', message.data.nodes);
								this.last_sites  = message.data.last_sites;
							break;
							case 'node_update':
								this.$store.commit('setNodes', message.data);
							break;
							case 'last_sites':
								this.last_sites  = message.data;
							break;
							case 'node_last_catch':
								this.$store.commit('setNodeLastCatch', message.data);
							break;
							case 'unlock_node':
								this.$store.commit('unlockNode', message.data);
								this.$store.commit('setMatrixInfo');
							break;
							case 'node_change_host':
								this.$store.commit('setNodeHost', message.data);
								this.$store.commit('setMatrixInfo');
							break;
							case 'upgrade_node':
								this.$store.commit('upgradeNode', message.data);
							break;
							case 'upgrade_structure':
								this.$store.commit('upgradeStructure', message.data);
							break;
							case 'assign_vairus':
								this.$store.commit('assignVairus', message.data);
							break;
							case 'node_progress':
								this.$store.commit('nodeProgress', message.data);
							break;
						}
					break;
				}
			}.bind(this));
		},
		methods: {
			closeDetail(){
				if(this.back_to_dashboard == true){
					this.back_to_dashboard = false
					this.$parent.current_panel = 0;
				}
				this.selected_node = null;
			},
			selectNode(node_id){
				this.new_node_site = '';
				this.selected_node = node_id;
			},
			nextNode(type){
				let current_index = this.nodes.findIndex(function(n){ 
					return n.id == this.selected_node; 
				}.bind(this));
				
				if(type == 'next'){
					var new_index = (current_index+1)%this.nodes.length;
				}else{
					var new_index = (current_index == 0) ? this.nodes.length-1 : current_index-1;
				}
				
				this.selectNode(this.nodes[new_index].id);
			},
			unlockNode(){
				if(this.start_process_lock) return;
				this.$store.commit('setActionLock', 'unlock_node_lock');
			
				browser.runtime.sendMessage({
					type : 'unlock_node',
					data : { 
						node_id : this.selected_node.replace('n', ''),
						site : this.new_node_site,
					}
				});
			},
			getNodeType(id){
				let node = this.grid_nodes.find(function(n){
					return n.id = id;
				});
				return node.type;
			},
			assignVairus(vairus_id){
				browser.runtime.sendMessage({
					type : 'assign_vairus',
					data : { 
						node_id : this.selected_node.replace('n', ''),
						vairus_id : vairus_id
					}
				});
				this.structure_vairus_list.active = false;
			},
			requestList(){
				this.structure_vairus_list.list = this.vairus_list;
				this.structure_vairus_list.active = true;
			},
			closeList(){
				this.structure_vairus_list.active = false;
			},
			parseTime(timestamp){
				let s = Math.floor((timestamp / 1000) % 60);
				let m = Math.floor((timestamp / (1000 * 60)) % 60);
				let h = Math.floor((timestamp / (1000 * 60 * 60)) % 24);
				
				if(h > 0){
					return  h.toString().padStart(2, '0')+':'+m.toString().padStart(2, '0')+':'+s.toString().padStart(2, '0');
				}else{
					return  m.toString().padStart(2, '0')+':'+s.toString().padStart(2, '0');
				}
			}
		},
		computed:{
			currentNodeType(){
				return this.getNodeType(this.selected_node);
			},
			getNodeCost(){
				if(this.nodes.length == 1) return 10000;
				return this.selectedNode.cost;
			},
			selectedNode(){
				let selected_node = this.grid_nodes.find(function(n){
					return n.id == this.selected_node;
				}.bind(this));
				
				return selected_node;
			},
			checkUnlockRequirement(){
				let locked = false;
				
				if(this.bytes < this.getNodeCost){
					locked = true;
				}
				
				if(this.selectedNode.type == 'builder' && this.new_node_site == ''){
					locked = true;
				}
				
				return locked;
			},
			validSites(){
				let current_hosts = this.nodes.map(function(node){ return node.host; });
				return this.last_sites.filter(function(site){
					return current_hosts.indexOf(site.url) === -1;
				});
			},
		},
		mixins: [commonMixin, structuresMixin, storeGettersMixin],
		components: {
			VairusList,
			GridNode,
			VButton,
			CloseIcon,
			EmptyCard,
			Builder,
			Incubator,
			Keygen,
			Decrypter,
			Compiler
		}
	}
</script>


<style lang="scss">
	@import "../styles/variables";

	#nodes{
		position: relative;
		
		
		
		.nodes-grid{
			position: relative;
			background-size: cover;
			margin: 80px 0;
			
			.graph{
				padding-top: 50%;
			}
			
			.cover{
				position: absolute;
				left: 0;
				top: 0;
				width: 100%;
				height: 100%;
				background: radial-gradient(ellipse at center, rgba(17,7,15,0) 30%, rgba(17,7,15,1) 100%);
			}
			
			.title{
				position: absolute;
				left: 0;
				top: -60px;
			}
			
			.path{
				position: absolute;
				width: 2px;
				background-color: #2a3538;
				transform-origin: top;
			}
			
			.active .path{
				background-color: #FEB3FF;
				box-shadow: 0px 0px 3px 0px #FEB3FF;
			}
			
			.network-score{
				position: absolute;
				top: -60px;
				right: 0;
				
				.score-bar{
					position: relative;
					width: 100%;
					margin-top: 5px;
					
					
					.bar{
						position: relative;
						height: 6px;
						background-color: #4A3349;
						border: 1px solid black;
						
						.dot{
							position: absolute;
							top: 50%;
							transform: translate(-5px, -50%);
							width: 11px;
							height: 11px;
							border-radius: 50%;
							border-width: 3px;
							border-style: solid;
							
							&:before{
								box-shadow: none;
							}
						}
						
						.base{
							height: 100%;
							transition: width 0.1s;
							width: 0;
							transition: width 0.3s linear;
						}
					}
				}
			}
		}
		
		.nodes-panel,
		.structure-panel{
			width: 100%;
		}
		
		.structure-panel{
			position: fixed;
			left: 0;
			top: 0;
			width: 100%;
			height: 100%;
			opacity: 0;
			pointer-events: none;
			transition: 0.3s opacity;
			z-index: 5;
			
			&.active{
				opacity: 1;
				pointer-events: all;
			}
			
			
			.backdrop{
				position: absolute;
				top: 0;
				left: 0;
				bottom: 0;
				right: 0;
				background-color: rgba(0, 0, 0, 0.7);
			}
			
			&> .wrapper{
				position: absolute;
				top: 50%;
				left: 0;
				transform: translateY(-50%);
				width: 100%;
				
				.panel.columns-8{
					background-color: black;
					border-radius: 10px;
					width: 933px;
					max-height: 94vh;
					max-width: 95vw;
					scrollbar-width: thin;
					scrollbar-color: $darkestpink $black;
					
					&[data-type=builder]{
						width: 1133px;
					}
					
					&::-webkit-scrollbar {
						width: 8px;
					}
					&::-webkit-scrollbar-track {
						background-color: $black;
					}
					&::-webkit-scrollbar-thumb {
						background-color: $darkestpink;
					}
					
					.node{
						padding: 20px;
					}
				}
			}
			
			.close-button{
			    position: absolute;
				top: 20px;
				right: 20px;
				z-index: 3;
			}
			
			.unlock-node{
				position: relative;
				
				.label{
					position: absolute;
					bottom: calc(100% + 25px);
				}
				
				.description{
					padding-left: 100px;
					padding-right: 50px;
				}
				
				.info{
					margin-top: 20px;
				
					.logo{
						width: 50px;
						height: 50px;
						margin-right: 20px;
						border-radius: 50%;
						border: 5px solid $lightazure;
						box-shadow: 0px 0px 30px 0px $lightazure;
						background-position: center;
						background-repeat: no-repeat;
						background-size: 24px 24px;
						flex-shrink: 0;
					}
							
					.avaiable-sites{
						border-spacing: 0;
					
						.website{
							background-color: $darkestpink;
							border-radius: 10px;
							margin-bottom: 10px;
							cursor: pointer;
							
							.host{
								padding: 10px 20px;
								transition: all 0.2s;
							}
							.choose{
								padding: 10px 20px;
								background-color: $lightestpink;
								color: $darkestpink;
								border-top-right-radius: 10px;
								border-bottom-right-radius: 10px;
								
								span{
									opacity: 1;
									transition: opacity 0.2s;
								}
							}
							
							&.selected{
								.host{
									padding: 10px 20px;
									background-color: $lightestpink;
									color: $darkestpink;
									border-top-left-radius: 10px;
									border-bottom-left-radius: 10px;
								}
								.choose span{
									opacity: 0;
								}
							}
						}
					}
				}
			}
			
			.node{	
				.header{
					margin-bottom: 20px;
					
					.node-info{
						min-width: 180px;
						min-height: 80px;
					
						.type{
							margin-bottom: 5px;
						}
					}
						
					.level-bar{
						position: relative;
						width: 100%;
						padding: 0 20px;
						margin-top: 5px;
						
						
						.bar{
							position: relative;
							height: 6px;
							background-color: #4A3349;
							border: 1px solid black;
							overflow: hidden;
							
							.base{
								height: 100%;
								transition: width 0.1s;
								width: 0;
								transition: width 0.3s linear;
							}
						}
						
						.bonus{
							position: absolute;
							left: 0;
							margin-top: 5px;
							
							.icon{
								position: absolute;
								top: -13.5px;
								width: 11px;
								height: 11px;
								border-radius: 50%;
								border-width: 3px;
								border-style: solid;
								
								&:before{
									box-shadow: none;
								}
							}
							
							&.active .icon{
								background-color: $lightestpink;
							}
							
							.effect{
								white-space: nowrap;
							}
						}
					}
					
					.tutorial-icon{
						margin-right: 30px;
					}
				}
				
				.content{
					padding: 25px;
					
					> .info-box{
						position: absolute;
						top: calc(0% - 18px);
						left: 50%;
						transform: translateX(-50%);
					}
					
					&.special{
						display: inline-block;
						margin-top: 20px;
						margin-bottom: 40px;
						padding: 0 !important;
						background-color: #41063F;
						border-radius: 50px;
						
						&:before{
							border-radius: 50px;
						}
						
						.top-section{
							height: 60px;
							padding: 30px 60px 10px;
								
							.arrow{
								font-size: 3rem;
								height: 20px;
								line-height: 15px;
							}
						}
						.action{
							transition: height 0.2s;
							height: 0;
							
							&.assigned{
								height: 30px;
							}
							
							.start,
							.stop{
								padding: 5px 60px;
								cursor: pointer;
							}
						}
						.assignment{
							position: relative;
							background-color: #150114;
							padding: 0 30px;
							overflow: hidden;
							
							> .wrapper{
								background-color: #895A8A;
								
								.vairus-card,
								.empty-card{
									margin: 0;
								}
							}
						}
						
						.bottom-section{
							height: 60px;
						}
					
						.time{
							top: unset !important;
							bottom: calc(0% - 18px);
						}
						
						&.active{
							.assignment{
								> .wrapper{
									background-color: black;
								}
							}
						}
					}
				}
			}
		}
		
		
		.vairus-list-container{
			position: fixed;
			top: 0;
			left: 0;
			width: 100%;
			height: 100%;
			z-index: 2147483647;
			background-color: rgba(0,0,0,0.7);
			
			.main-column{
				height: 100%;
			
				.inner{
					position: absolute;
					top: 5%;
					left: 0;
					width: 100%;
					height: 90%;
					background-color: $background_color;
					border-radius: 10px;
					color: white;
					scrollbar-width: thin;
					scrollbar-color: $darkazure #4A3349;
					overflow-y: auto;
					
					> .wrapper{
						padding: 50px 2.5% 0;
					}
					
					&::-webkit-scrollbar {
						width: 8px;
					}
					&::-webkit-scrollbar-track {
						background-color: #4A3349;
					}
					&::-webkit-scrollbar-thumb {
						background-color: $darkazure;
					}
				}
			}
			
		}
		
		
		@media screen and (max-width: 700px) {
			.nodes-grid {
				padding-bottom: 100px;
				
				.graph{
					transform: scale(1.25) translateY(50px);
				}
			}
			.nodes-grid .network-score{
				width: 50%;
			}
			.last-site-selector .columns-6{
				width: 100%;
			}
			.structure-panel .unlock-node .description{
				padding-left: 50px;
			}
		}
		@media screen and (max-width: 600px) {
			.structure-panel .unlock-node .description{
				padding-left: 25px;
				padding-right: 35px;
			}
			
			.last-site-selector{
				.host{
					display: block;
					
					div:first-child{
						margin-bottom: 5px;
					}
				}
				.choose{
					padding-top: 23px !important;
				}
			}
		}
		
		@media screen and (max-width: 500px) {
			.nodes-grid .graph{
				transform: scale(1.35) translateY(50px);
			}
			.last-site-selector{
				.website{
					margin-left: -70px;
				}
			}
		}
	}
	
</style>
